local toggleframe = ""
local lfg_text_changed=false
local lfg_default_template = "Suche für $instance($mode): $member."
local lfg_text_template = "Suche für $instance($mode): $member."
local lfg_editbox="LFGToolEditBox"
local lfg_instance_editbox="LFGToolInstanceEditBox"
local lfg_default_instance="Instanz"
local lfg_channel_list= {"BlizzLFG","LFG","GuildLFG"}

--[[Definition der UI-Unterfenster für die Klassensselektion
-- {"Name", Unterfenster vorhanden}
--]]
local uiclass_table = {
					heal = {"Heal",true},
					tank = {"Tank",true},
					damage = {"Damage",true},
					random = {"Random",false}
			}

--[[Definition der Klassen für die Suchanfrage
-- {"Name", Soll im Suchstring erscheinen}
-- diese Tabellen korrespondieren mit den entsprechenden
-- Checkboxen und alle Werte mit true werden in die
-- member_table eingefügt.
--]]
local tank_table = {
				["Tank"]=false,
				["Krieger"]=false,
				["Druide"]=false,
				["Paladin"]=false,
			}
local heal_table = {
				["Heal"]=false,
				["Priester"]=false,
				["Paladin"]=false,
				["Schamane"]=false,
				["Druide"]=false,
			}
local damage_table = {
				["Damage"]=false,
				["Hexenmeister"]=false,
				["Magier"]=false,
				["Schurke"]=false,
				["Schamane"]=false,
				["Jäger"]=false,
			}
local random_table = {
				["Random"]=false
			}
local class_table = {
				["Tank"] = tank_table,
				["Heal"] = heal_table,
				["Damage"] = damage_table,
				["Random"] = random_table
			}
local member_table = {}

function LFGTool_OnLoad()
  out("LFGTool: Aufruf mit /lfgt");
  SLASH_LFGTOOL1 = "/lfgtool";
  SLASH_LFGTOOL2 = "/lfgt";
  SlashCmdList["LFGTOOL"] = LFGTool_SlashCommandHandler;
	editbox=getglobal(lfg_editbox);
	editbox:SetText(lfg_text_template);
	editbox=getglobal(lfg_instance_editbox);
	editbox:SetText(lfg_default_instance);
end

function out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
 UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end

function LFGTool_SlashCommandHandler(msg)
		if (msg=="") then
			LFGTool_Toggle();
		else
			if (msg == "reset") then
				editbox=getglobal(lfg_editbox);
				editbox:SetText(lfg_default_template);
			end
		end
end

function LFGTool_Toggle()
	local frame = getglobal("LFGTool");
	if (frame) then
		if(frame:IsVisible()) then
			frame:Hide();
		else
			frame:Show();
		end
	end
end


function LFGTool_ClassSelectionToggle(text)
	local frame = nil
	for key,value in pairs(uiclass_table) do
		if (value[2] == true) then
			frame=getglobal(value[1] .. "SelectionFrame");
			if (value[1] == text) then
				if (frame:IsVisible()) then
					frame:Hide();
				else
					frame:Show();
				end
			else
				frame:Hide();
			end
		else
			if (value[1] == text) then
				local checkbox=getglobal(text.."CheckButton");
				if (checkbox:GetChecked()==1) then
					checkbox:SetChecked(0);
				else
					checkbox:SetChecked(1);
				end
			end
		end
	end
end

function LFGTool_CheckBoxHandler(category,subclass)
	local cbox = nil
	if (subclass == "") then
		cbox=getglobal(category .. "CheckButton");
		if (cbox:GetChecked() == 1) then
			class_table[category][category]=true;
		else
			class_table[category][category]=false;
		end
	else
		cbox=getglobal(subclass .. category .. "CheckButton");
		if (cbox:GetChecked() == 1) then
			class_table[category][subclass]=true;
		  cbox=getglobal(category .. "CheckButton");
			cbox:SetChecked(1)
			class_table[category][category]=true;
		else
			class_table[category][subclass]=false;
		end
	end
end

function LFGTool_InstanceSelectionToggle (text)
	if (text~="NoToggle") then
		local frame=getglobal("InstanceSelectionFrame");
		if (frame:IsVisible()) then
			frame:Hide();
		else
			frame:Show();
		end
	end
	local editbox=getglobal(lfg_instance_editbox)
	local text = editbox:GetText()
	local button=getglobal("InstanceButton");
	button:SetText(text);
end

function LFGTool_ChannelSelectionToggle (text)
	local frame=getglobal("ChannelSelectionFrame")
	if (frame:IsVisible()) then
		frame:Hide();
	else
		frame:Show();
	end
end

function LFGTool_InstanceChallengeToggle()
	local button=getglobal("HeroicButton");
	local text=button:GetText();
	if (text=="Normal") then
		text = "Hero"
	else
		text = "Normal"
	end
	button:SetText(text)
end

function LFGTool_GetScStr(tac_class)
	local temp_str = "";
	local temp_table = class_table[tac_class];
	local counter = 0;
	
	for class,bool_val in pairs(temp_table) do
		if ((class~=tac_class) and (bool_val==true)) then
			if (temp_str=="") then
				temp_str=class;
			else
				temp_str=class .. ',' .. temp_str;
			end
			counter=counter+1
		end
	end

	if (counter==0) then
		temp_str=tac_class;
	else
		temp_str=tac_class .. '(' .. temp_str .. ')'
	end

	return temp_str
end

function LFGTool_Test()
	-- %member -> member_table
	-- %instance -> InstanceButton
	-- %mode -> HeroicButton
	local button_mode = getglobal("HeroicButton");
	local button_instance = getglobal("InstanceButton");
	local member="";
	local temp_member="";
	for tc,tc_table in pairs(class_table) do
		if (tc_table[tc]==true) then
			temp_member=LFGTool_GetScStr(tc);
			if (member=="") then
				member=temp_member;
			else
				member=temp_member .. ', ' .. member;
			end
		end
	end
	local text = string.gsub (lfg_text_template,"$member",member);
	text = string.gsub(text,"$instance",button_instance:GetText());
	text = string.gsub(text,"$mode",button_mode:GetText());
	out (text);
end 

function LFGTool_UpdateLFGText()
	editbox=getglobal(lfg_editbox)
	local text = editbox:GetText()
	lfg_text_template=text;
end

function LFGTool_Send()
	-- %member -> member_table
	-- %instance -> InstanceButton
	-- %mode -> HeroicButton
	local button_mode = getglobal("HeroicButton");
	local button_instance = getglobal("InstanceButton");
	local member="";
	local temp_member="";
	for tc,tc_table in pairs(class_table) do
		if (tc_table[tc]==true) then
			temp_member=LFGTool_GetScStr(tc);
			if (member=="") then
				member=temp_member;
			else
				member=temp_member .. ', ' .. member;
			end
		end
	end
	local text = string.gsub (lfg_text_template,"$member",member);
	text = string.gsub(text,"$instance",button_instance:GetText());
	text = string.gsub(text,"$mode",button_mode:GetText());
	local channel_id = nil;
	local channel_type = nil;
	for k,cbox_id in ipairs(lfg_channel_list) do
		cbox=getglobal(cbox_id .. "CheckButton");
		if (cbox~=nil) then
			if (cbox:GetChecked() == 1) then
				if (cbox_id=="BlizzardLFG") then
					channel_id="4";
					channel_type ="CHANNEL";
				elseif (cbox_id=="LFG") then
					channel_id,name=GetChannelName("lfg");
					channel_type ="CHANNEL";
					SendChatMessage(text,channel_type,nil,channel_id)
				elseif (cbox_id=="Guild") then
					channel_type ="GUILD";
					SendChatMessage(text,channel_type,nil);
				end
			end
		else
			out ("Channel " .. cbox_id .. ":" .. cbox_id .."CheckButton");
		end
	end		
end

function LFGTool_TestLua()
	local test_table = {
			["one"]=false,
			["two"]=true,
			["three"]=false
	};
	for k,v in pairs(test_table) do
			out (k);		
	end
	a=#test_table
	out(a);
	test_Str="123";
	out(#test_Str);
end
